{-------------------------------------------------------------------------------
Copyright (c) 2010, Ortus bvba, Belgium
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice, this
  list of conditions and the following disclaimer in the documentation and/or
  other materials provided with the distribution.
* Neither the name of "Ortus" nor the names of its contributors may be used to
  endorse or promote products derived from this software without specific prior
  written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-------------------------------------------------------------------------------}

{$ObjExportAll On}
unit OrtusShellAbout;

interface

uses
  Windows, Messages, Classes, SysUtils, StdCtrls, Controls, Graphics, Forms,
  ShellApi;

type
  TOrtusShellAbout= class(TComponent)
  private
    FCaption: string;
    FShortText: string;
    FLongText: string;
    FIcon: TIcon;
  protected
    procedure Loaded; override;
  public
    constructor Create(Owner: TComponent); override;
    destructor Destroy; override;

    function Execute: Boolean;
  published
    property Caption: string read FCaption write FCaption;
    property ShortText: string read FShortText write FShortText;
    property LongText: string read FLongText write FLongText;
  end;

implementation

//------------------------------------------------------------------------------
// TOrtusShellAbout
//------------------------------------------------------------------------------

procedure TOrtusShellAbout.Loaded;
begin
  inherited Loaded;
end;

constructor TOrtusShellAbout.Create(Owner: TComponent);
begin
  inherited Create(Owner);

  FIcon := TIcon.Create;
end;

destructor TOrtusShellAbout.Destroy;
begin
  FIcon.Free;

  inherited Destroy;
end;

function TOrtusShellAbout.Execute: Boolean;
begin
  Result := ShellAbout(Application.Handle, PChar(FCaption + '#' + FShortText), PChar(FLongText), FIcon.Handle) <> 0;
end;

end.
