{-------------------------------------------------------------------------------
Copyright (c) 2010, Ortus bvba, Belgium
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice, this
  list of conditions and the following disclaimer in the documentation and/or
  other materials provided with the distribution.
* Neither the name of "Ortus" nor the names of its contributors may be used to
  endorse or promote products derived from this software without specific prior
  written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-------------------------------------------------------------------------------}

{$ObjExportAll On}
unit OrtusShellOrganizeFavorites;

interface

{$I COMPVER.INC}

uses
  Windows, Messages, Classes, SysUtils, StdCtrls, Controls, Graphics, Forms,
  ShellApi, ShlObj, ActiveX;

type
  TOrtusShellOrganizeFavorites= class(TComponent)
  private
  protected
    procedure Loaded; override;
  public
    constructor Create(Owner: TComponent); override;
    destructor Destroy; override;

    function Execute: Boolean;
  end;

implementation

procedure FreePIDL(PIDL: PItemIDList);
var
  ShellMalloc: IMalloc;
begin
  SHGetMalloc(ShellMalloc);
  try
    if PIDL <> nil then ShellMalloc.Free(PIDL);
  finally
    ShellMalloc := nil;
  end {try};
end;

//------------------------------------------------------------------------------
// TOrtusShellOrganizeFavorites
//------------------------------------------------------------------------------

procedure TOrtusShellOrganizeFavorites.Loaded;
begin
  inherited Loaded;
end;

constructor TOrtusShellOrganizeFavorites.Create(Owner: TComponent);
begin
  inherited Create(Owner);
end;

destructor TOrtusShellOrganizeFavorites.Destroy;
begin
  inherited Destroy;
end;

function TOrtusShellOrganizeFavorites.Execute: Boolean;
type
  TSHOrganizeFavoritesProc= function(Wnd: THandle; Path: LPTSTR): Integer; stdcall;
var
  ModuleHandle: THandle;
  OrganizeFavoritesProc: TSHOrganizeFavoritesProc;
  PIDL: PItemIDList;
  P: array[0..255] of Char;
begin
  Result := False;
  ModuleHandle := LoadLibrary('SHDOCVW.DLL');
  if ModuleHandle = 0 then Exit;
  try
    OrganizeFavoritesProc := GetProcAddress(ModuleHandle, 'DoOrganizeFavDlg');
    if @OrganizeFavoritesProc = nil then Exit;
    SHGetSpecialFolderLocation(Application.Handle, CSIDL_FAVORITES, PIDL);
    try
      FillChar(P, SizeOf(P), #0);
      SHGetPathFromIDList(PIDL, P);
      OrganizeFavoritesProc(Application.Handle, P);
    finally
      FreePIDL(PIDL);
    end {try};
  finally
    FreeLibrary(ModuleHandle);
  end {try};
end;

end.
